/* Xbee AT conmmand support functions */

#define _xbee_at_c_

#include "project_config.h"
#include <string.h>

/* strings	*/
//const rom char *const rom resp_err = "ERROR\r";
/* AT commands	*/
const rom char *const rom three_pluses = "+++";
const rom char *const rom at_cmdmode_exit = "ATCN\r";
/* External variables	*/
extern DWORD uptime;

BOOL Xbee_init( void )
{
	if( Xbee_cmdmode_enter() == FALSE ) {	//enter command mode
		return( FALSE );
	}
	send_string("ATSM1\r");
	if( Xbee_waitfor_OK() == FALSE ) {
		return( FALSE );
	}
	if( Xbee_cmdmode_exit() == FALSE ) {
		return( FALSE );
	}
	return( TRUE );
}

/* switching Xbee to command mode 	*/
/* returns TRUE if OK is received	*/
/* assumes DWORD uptime incrementing each millisecond	*/
BOOL Xbee_cmdmode_enter( void )
{
 DWORD delay;
 	delay = uptime + 2000;
 	while( uptime < delay );	//wait 1 sec guard time
 	send_string(three_pluses);
	if( Xbee_waitfor_OK() ) {
		return( TRUE );
	}
	return( FALSE );
}
/* command mode assumed			*/
/* returns TRUE if OK received	*/
BOOL Xbee_cmdmode_exit( void )
{
 //DWORD delay;	
	send_string( at_cmdmode_exit );
	if( Xbee_waitfor_OK() ) {
		return( TRUE );
	}
	//delay = uptime + 500;
	//while( uptime < delay );	//wait half sec
	return( FALSE );
}
/* reads serial stream expecting OK					*/
/* returns TRUE if received							*/
/* assumes 'uptime' incrementing each millisecond	*/
BOOL Xbee_waitfor_OK( void )
{
 BOOL rcode = FALSE;
 char buf[ 4 ] = { 0 };
 BYTE i = 0;
 DWORD timeout;
 rom char *resp_ok = "OK\r";
	timeout = uptime + 2000;	//timeout 2 sec
	while( uptime < timeout ) {
	if( CharInQueue()) {
 			buf[ i ] = recvchar();
 			i++;
 		}
 		if( strcmppgm2ram( buf, (const far rom char *)"OK\r" ) == 0 ) {
 			rcode = TRUE;
 			break;
 		}
 	}
 	return( rcode );	
}
